/**********************************************************************
 *
 * mgq.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: mgq.h 324 1999-07-01 03:52:05Z rjmcnab $
 *
 *********************************************************************/


#ifndef MGQ_H
#define MGQ_H

#ifdef __cplusplus
extern "C" {
#endif

  
enum result_kinds {
  result_docs,      /* Return the documents found in last search */
  result_docnums,   /* Return document id numbers and weights */
  result_termfreqs, /* Return terms and frequencies */
  result_terms      /* Return matching query terms */
};

int mgq_ask(char *line);
int mgq_results(enum result_kinds kind, int skip, int howmany,
		int (*sender)(char *, int, int, float, void *), void *ptr);
int mgq_numdocs(void);
int mgq_numterms(void);

/* get all the terms that match wordstem using the current stemmer and */
/* stemming method. The callback is the same style used by mgq_results */
int mgq_equivterms (unsigned char *wordstem, int (*sender)(char *, int, int, float, void *),
		    void *ptr);
  
/* use mgq_getmaxstemlen to determine the length of the word stems to pass */
/* to mgq_stemword */
int mgq_getmaxstemlen ();

/* note: the stemming method and the stemmer come from the last query */
/* "word" should be at least maxstemlen+1 long and it is a string that */
/* starts with the string length */
void mgq_stemword (unsigned char *word);

  
int is_dbcache_full (void);
int load_database (char *collection, char *mgdir, char *gensuffix, char *textsuffix);
int load_text_database (char *collection);
void close_all_databases (void);


#ifdef __cplusplus
}
#endif


#endif
